# Log

[![pipeline status](https://git.iiens.net/brateau2015/diglog/badges/master/pipeline.svg)](https://git.iiens.net/brateau2015/diglog/commits/master)

Log (diglog + analog) is a graphical environment for entering circuit
schematics, and for analog and digital circuit simulation. Please see
[previous README](README.old) for more information.

This is a fork of a part of the [Chipmunk
Distribution](https://john-lazzaro.github.io/chipmunk/pickup/pickup.html)
maintained by [John Lazzaro](https://github.com/john-lazzaro).

This repo has for goal to get rid of old code and make the rest compliant with
modern practices, protocols, frameworks and operating systems/architectures.

Later on, we might add new features.

## Compilation instructions

### Dependencies

For Debian :

* `libx11-dev` i686 edition
* `build-essential`

For Fedora/Red Hat :

* `libX11-devel.i686`
* `glibc-devel.i686`

And if you want `sudo dnf group install "Development Tools"`.

### On Linux systems

Then just type :

```
$ make
```

## Tests

All tests are in the test folder.
To build unittests, install [criterion](https://criterion.readthedocs.io/en/master/setup.html).

Then just type :

``
$ make test
```

You can run the test by running the test/test program.

## Static analysis

_Not yet implemented_

## Codestyle checks

_Not yet implemented_

## License

```
    diglog
    Copyright (C) 2018  Etienne BRATEAU

   "LOG", the circuit editing and simulation system
   "DigLOG", the digital simulator for LOG.
    Copyright (C) 1985, 1990 David Gillespie.
    Author's address: daveg@synaptics.edu

    "AnaLOG", the analog simulator for LOG, 5.66
    Copyright (C) 1985, 1990 John Lazzaro.
    Author's address: lazzaro@cs.berkeley.edu;

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
```
