#ifndef P2C_STRING_H
#define P2C_STRING_H

#include <utils/p2c.h>

/**
 * Append the second string to the first.
 *
 * \deprecated use strcat instead
 */
void strsafeappend(char *s, char *s2) DEPRECATED;

/**
 * Put the string in upper case
 */
char *strupper (char *result, char *s);

/**
 * Put the string in lower case
 */
char *strlower (char *result, char *s);

/**
 * Return a substring by the begin and end of wanted part.
 * Result must be free.
 */
char *strpart (char *result, char *s, long fist, long last);
char *strlast (char *result, char *s, size_t num);
char *strreverse (char *result, char*);
char *strcjust (char *result, char *s, size_t wid);
int strbegins (char *s1, char *s2);
int strends (char *s1, char *s2);
int strcibegins (char *s1, char *s2);
int strciends (char *s1, char *s2);
int strsubcmp (size_t n, char *s1, size_t i1, char *s2, size_t i2);
int strcisubcmp (size_t n, char *s1, size_t i1, char *s2, size_t i2);
void strsubst (char *repl, char *s, size_t index, size_t size);
char *strint (char *result, long i);
char *strint2 (char *result, long i, long w);
char *strchar (char *result, int ch);
size_t strposb (char *s1, char *s2, ptrdiff_t i);
size_t strposc (char *s1, char ch, ptrdiff_t i);
size_t strposcset (char *s1, char *s2, size_t i);
size_t strposbcset (char *s1, char *s2, size_t i);
size_t strcipos2 (char *s1, char *s2, size_t i);
size_t strciposb (char *s1, char *s2, size_t i);
int strsubset (char *s1, char *s2);
int strcommon (char *s1, char *s2);
size_t strlenv (char *s);
char *strhex (char * Result, long i, long w);
char *strbinary (char *Result, long i, size_t w);
char *strdate (char *Result, char *opts);
void strword (char *s, char *s2);
void strword2 (char *s, char *s2);
void strcomment (char *s, char* bracket);
void strcompress (char *s, char *chars, int all);
void strdispose (char **sp);
void strchange (char** sp, char *);
void strwordx (char *buf, char *wrd);
char *strsub (char *, char *, size_t, size_t);
char *strltrim (char *);
char *strrtrim (char *);
size_t strpos2 (char *, char *, size_t);
void strmove (size_t len, char * s, size_t spos, char * d, size_t dpos);
int  strcicmp (char * s1, char * s2);


/**
 * \deprecated
 */
char *strcpy_overlap(char *dst, char *src) DEPRECATED;

#endif
