#include <utils/strings.h>
#include <criterion/criterion.h>

Test(strings, strupper) {
	char *test = malloc(sizeof(char) * 5);
	strcpy(test, "test");
	test = strupper(test, test);
	cr_expect_str_eq(test, "TEST", "simple test of upper");

	strcpy(test, "TrOu");
	test = strupper(test, test);
	cr_expect_str_eq(test, "TROU", "Other test of upper");
	free(test);
}

Test(strings, strlower) {
	char *test = malloc(sizeof(char) * 5);
	strcpy(test, "TEST");
	test = strlower(test, test);
	cr_expect_str_eq(test, "test", "simple test of lower");

	strcpy(test, "TrOu");
	test = strlower(test, test);
	cr_expect_str_eq(test, "trou", "Other test of lower");
	free(test);
}

Test(strings, strreverse) {
	char *test = malloc(sizeof(char) * 5);
	strcpy(test, "test");
	test = strreverse(test, test);
	cr_expect_str_eq(test, "tset", "simple test of reverse");

	test = realloc(test, sizeof(char) * 6);
	strcpy(test, "kayak");
	test = strreverse(test, test);
	cr_expect_str_eq(test, "kayak", "palindrome test of reverse");
	free(test);
}
